summaryrefslogtreecommitdiffstats
path: root/scripts
diff options
context:
space:
mode:
authorSlávek Banko <slavek.banko@axis.cz>2012-09-06 00:11:44 +0200
committerSlávek Banko <slavek.banko@axis.cz>2012-09-08 12:37:21 +0200
commit62ae98b3084d7521bf655d611774bfb12f5aaa1f (patch)
tree7e311469358509869593f240bac1e8bbcbc957e5 /scripts
parent595bc9f1ca8321ac43ca458627eb7ac4377a39fd (diff)
downloadtde-62ae98b3084d7521bf655d611774bfb12f5aaa1f.tar.gz
tde-62ae98b3084d7521bf655d611774bfb12f5aaa1f.zip
Added submodules for v3.5.13-sru branch
Added flat listing of submodules Updated GIT readme file Added scripts
Diffstat (limited to 'scripts')
-rw-r--r--scripts/README2
-rwxr-xr-xscripts/commit_all_submodules48
-rwxr-xr-xscripts/switch_all_submodules_to_head_and_clean60
-rwxr-xr-xscripts/update_all_submodules70
4 files changed, 180 insertions, 0 deletions
diff --git a/scripts/README b/scripts/README
new file mode 100644
index 000000000..2f1f6175e
--- /dev/null
+++ b/scripts/README
@@ -0,0 +1,2 @@
+All useful GIT helper scripts should go here
+This includes scripts useful to the TDE developers for pushing batch changes, etc.
diff --git a/scripts/commit_all_submodules b/scripts/commit_all_submodules
new file mode 100755
index 000000000..ce3a8c7ab
--- /dev/null
+++ b/scripts/commit_all_submodules
@@ -0,0 +1,48 @@
+#!/bin/bash
+
+if [[ ! -e .git ]] ||
+ [[ -z "`git rev-parse --git-dir 2>/dev/null`" ]]; then
+ echo "This script can only be run from a top level git directory. Exiting..."
+ exit 1
+fi
+
+branch=`git symbolic-ref --short -q HEAD`
+if [[ -z "$branch" ]] ||
+ [[ -z "`git rev-parse --symbolic-full-name --remotes=\"*/$branch\"`" ]]; then
+ echo "There is not active upstream branch. Exiting..."
+ exit 1
+fi
+
+echo "Preparing $PWD for development use"
+if [[ $1 == "" ]]; then
+ gituser=`sed -n "/^\[remote \"origin\"\]/,/url/s/\turl = http:\/\/\([^@]*\)@.*/\1/p" <\`git rev-parse --git-dir\`/config | grep -v "\(anonymous\|system\)"`
+else
+ gituser=$1
+fi
+
+if [[ $gituser == "" ]]; then
+ read -p "Enter your TDE GIT username []: " -e gituser
+fi
+
+if [[ $gituser == "" ]]; then
+ gituser="anonymous"
+fi
+
+read -p "Enter your commit message []: " -e commitmessage
+
+git submodule foreach "git commit -a -m \"$commitmessage\" || true"
+git submodule foreach "sed -i \"s/system@scm\.trinitydesktop\.org/$gituser@scm\.trinitydesktop\.org/g\" \`git rev-parse --git-dir\`/config"
+git submodule foreach "git pull &&\
+ [[ \"\`git rev-parse HEAD\`\" == \"\`git rev-parse origin/$branch\`\" ]] ||\
+ git push origin HEAD"
+RETCODE=$?
+if [[ $RETCODE != 0 ]]; then
+ echo "Something went wrong"
+ exit 1
+fi
+
+git commit -a -m "$commitmessage" || true
+sed -i "s/system@scm\.trinitydesktop\.org/$gituser@scm\.trinitydesktop\.org/g" `git rev-parse --git-dir`/config
+git pull &&\
+ [[ "`git rev-parse HEAD`" == "`git rev-parse origin/$branch`" ]] ||\
+ git push origin HEAD || true
diff --git a/scripts/switch_all_submodules_to_head_and_clean b/scripts/switch_all_submodules_to_head_and_clean
new file mode 100755
index 000000000..c35d9f817
--- /dev/null
+++ b/scripts/switch_all_submodules_to_head_and_clean
@@ -0,0 +1,60 @@
+#!/bin/bash
+
+if [[ ! -e .git ]] ||
+ [[ -z "`git rev-parse --git-dir 2>/dev/null`" ]]; then
+ echo "This script can only be run from a top level git directory. Exiting..."
+ exit 1
+fi
+
+branch=`git symbolic-ref --short -q HEAD`
+if [[ -z "$branch" ]] ||
+ [[ -z "`git rev-parse --symbolic-full-name --remotes=\"*/$branch\"`" ]]; then
+ echo "There is not active upstream branch. Exiting..."
+ exit 1
+fi
+
+echo "Preparing $PWD for development use"
+if [[ $1 == "" ]]; then
+ gituser=`sed -n "/^\[remote \"origin\"\]/,/url/s/\turl = http:\/\/\([^@]*\)@.*/\1/p" <\`git rev-parse --git-dir\`/config | grep -v "\(anonymous\|system\)"`
+else
+ gituser=$1
+fi
+
+if [[ $gituser == "" ]]; then
+ read -p "Enter your TDE GIT username []: " -e gituser
+fi
+
+if [[ $gituser == "" ]]; then
+ gituser="anonymous"
+fi
+
+THISSCRIPT=$(readlink -f $0)
+
+if [[ ! -e "$THISSCRIPT" ]]; then
+ echo "Unable to find myself! Exiting..."
+ exit 1
+fi
+
+if [[ ! -z "`git status --porcelain --ignore-submodules`" ]]; then
+ git reset --hard HEAD
+ git clean -dxff
+fi
+git pull
+if [[ ! -z "`git status --porcelain --ignore-submodules`" ]]; then
+ git reset --hard HEAD
+ git clean -dxff
+fi
+
+if [[ -e .gitmodules ]]; then
+ if [[ $gituser == "anonymous" ]]; then
+ sed -i 's/system@//g' .gitmodules
+ else
+ sed -i "s/system@/$gituser@/g" .gitmodules
+ fi
+
+ git submodule init
+ git submodule update
+ git submodule foreach "git checkout $branch && $THISSCRIPT $gituser"
+
+ git checkout -- .gitmodules
+fi
diff --git a/scripts/update_all_submodules b/scripts/update_all_submodules
new file mode 100755
index 000000000..46fcc6d2e
--- /dev/null
+++ b/scripts/update_all_submodules
@@ -0,0 +1,70 @@
+#!/bin/bash
+
+if [[ -e /var/lock/update-tde-git-submodules ]]; then
+ echo "TDE GIT submodules are currently being updated"
+ echo "If this is not the case, please remove the lockfile /var/lock/update-tde-git-submodules"
+ exit 0
+fi
+
+if [[ ! -e .git ]] ||
+ [[ -z "`git rev-parse --git-dir 2>/dev/null`" ]]; then
+ echo "Current directory does not contain a .git folder. Exiting..."
+ exit 1
+fi
+
+branch=`git symbolic-ref --short -q HEAD`
+if [[ -z "$branch" ]] ||
+ [[ -z "`git rev-parse --symbolic-full-name --remotes=\"*/$branch\"`" ]]; then
+ echo "There is not active upstream branch. Exiting..."
+ exit 1
+fi
+
+touch /var/lock/update-tde-git-submodules
+
+PARENTDIR=$PWD
+echo "Working in $PARENTDIR"
+git pull
+if [[ ! -z "`git status --porcelain --ignore-submodules`" ]]; then
+ git reset --hard HEAD
+ git clean -dxff
+fi
+
+exec 3< submodules
+while read <&3
+do
+ cd $PARENTDIR
+ DIR2UPDATE=$REPLY
+ if [[ $DIR2UPDATE != "" ]]; then
+ echo "Attempting to reset submodule $DIR2UPDATE"
+ cd $PARENTDIR/$DIR2UPDATE/..
+ cd `git rev-parse --show-toplevel`
+ if [[ -z "`grep \"^Updated: $PWD$\" /var/lock/update-tde-git-submodules`" ]]; then
+ echo "Updated: $PWD" >>/var/lock/update-tde-git-submodules
+ git submodule init
+ git submodule update
+ fi
+ cd $PARENTDIR/$DIR2UPDATE
+ if [[ ! -z "`git status --porcelain --ignore-submodules`" ]]; then
+ git reset --hard HEAD
+ git clean -dxff
+ fi
+ git checkout $branch
+ git pull
+ cd ..
+ cd `git rev-parse --show-toplevel`
+ echo "Committing changes to $PWD"
+ if [[ ! -z "`git status --porcelain $PARENTDIR/$DIR2UPDATE`" ]]; then
+ git add $PARENTDIR/$DIR2UPDATE
+ git commit $PARENTDIR/$DIR2UPDATE -m "Reset submodule $DIR2UPDATE to latest HEAD"
+ fi
+ if [[ "`git rev-parse HEAD`" != "`git rev-parse origin/$branch`" ]]; then
+ git push origin HEAD
+ fi
+ fi
+done
+exec 3>&-
+
+# Let the disk subsystem recover
+sleep 60
+
+rm /var/lock/update-tde-git-submodules